﻿var bbscmd = {
    // 获取用户头像连接
    user: {
        getLogo: function (username) {
            var user_logo = "https://avatar.cnool.net/forumavatar/bbsavatar.aspx?u=" + username + "&s=3";
            return user_logo;
        }
    },
    //bbsRuleText
    getRuleText: function (fn) {
        apicmd.getData("https://ucenterapi.cnool.net/wrapper/", "Other", "eula", "", {}, function (data, err) {
            if (data != undefined && data.ResponseCode == 0) {
                data.Content = data.Content.replace(/\r\n/g, "<br/>");
            }
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //判断管理员
    CheckAdmin: function (username, fn) {
        apicmd.getData(API_LIST.platform, "admin", "CheckAdmin", "username=" + username, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //判断版主
    CheckModerator: function (username, tagname, fn) {
        apicmd.submitData(API_LIST.platform, "admin", "CheckModerator", "", { username: username, tagname: tagname}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //删除文章
    delarticle: function (articleId, log, fn) {
        apicmd.submitData(API_LIST.platform, "article", "delarticle", "", {
            articleId: articleId,
            log: log
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    getloadurl: {
        getgx: function (fn) {
            apicmd.getData(API_LIST.platform, "appconfig", "", "", {}, function (data, err) {
                if (fn)
                    fn(data, err);
            }, 'json');
        }
    },
    //判断每日发帖数
    GetPostArticleCount: function (onSuccess) {
        apicmd.getData(API_LIST.platform, "UserAction","GetPostArticleCount","", {}, function (json) {
            if (onSuccess)
                onSuccess(json);
        });
    },
    //判断每日回帖数
    GetPostCommentCount: function (onSuccess) {
        apicmd.getData(API_LIST.platform, "UserAction","GetPostCommentCount","", {}, function (json) {
            if (onSuccess)
                onSuccess(json);
        });
    },
    //判断每日点赞数
    GetAddLikeCount: function (onSuccess) {
        apicmd.getData(API_LIST.platform, "UserAction","GetAddLikeCount","", {}, function (json) {
            if (onSuccess)
                onSuccess(json);
        });
    },
    //APP首页列表
    defaultList: function (PageId, fn,errfn) {
        apicmd.getData(API_LIST.platform, "article", "GetAppIndexList", "page=" + PageId + "&PageSize=10", {}, function (data, err) {
            for (i = 0; i < data.data.length; i++) {
                if (!data.data[i].CoverImage) {
                    data.data[i].CoverImage = [];
                }
                for (j = 0; j < data.data[i].CoverImage.length; j++) {
                    data.data[i].CoverImage[j] = replaceImg(data.data[i].CoverImage[j]);
                }
            };
            if (fn)
                fn(data, err);
        }, 'json', function (data,err) {
            if (errfn)
                errfn(data,err)
        });
    },
    //APP首页灵桥市场列表
    mallGetIndexList: function (PageId, fn, errfn) {
        apicmd.getData(API_LIST.platform, "mall", "GetIndexList", "page=" + PageId + "&PageSize=10", {}, function (data, err) {
            for (i = 0; i < data.data.length; i++) {
                if (!data.data[i].CoverImage) {
                    data.data[i].CoverImage = [];
                }
                for (j = 0; j < data.data[i].CoverImage.length; j++) {
                    data.data[i].CoverImage[j] = replaceImg(data.data[i].CoverImage[j]);
                }
            };
            if (fn)
                fn(data, err);
        }, 'json', function (data, err) {
            if (errfn)
                errfn(data, err)
        });
    },
    //APP首页热点列表
    hotList: function (PageId, fn, errfn) {
        apicmd.getData(API_LIST.platform, "article", "GetHotArticleHistory", "time=" + PageId, {}, function (data, err) {
            for (i = 0; i < data.data.length; i++) {
                if (!data.data[i].CoverImage) {
                    data.data[i].CoverImage = [];
                }
                for (j = 0; j < data.data[i].CoverImage.length; j++) {
                    data.data[i].CoverImage[j] = replaceImg(data.data[i].CoverImage[j]);
                }
            };
            if (fn)
                fn(data, err);
        }, 'json', function (data, err) {
            if (errfn)
                errfn(data, err)
        });
    },
    //编辑新闻
    unitedit: function (Title, Content, categoryTags, ArticleId, NotEditTitle, fn) {
        apicmd.submitData(API_LIST.platform, "unit", "edit", "", {
            Title: Title,
            Content: Content,
            categoryTags: categoryTags,
            ArticleId: ArticleId,
            NotEditTitle: NotEditTitle
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //编辑帖子
    forumedit: function (Title, Content, categoryTags, ArticleId, NotEditTitle, fn) {
        apicmd.submitData(API_LIST.platform, "forum", "edit", "", {
            Title: Title,
            Content: Content,
            categoryTags: categoryTags,
            ArticleId: ArticleId,
            NotEditTitle: NotEditTitle
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //举报
    reportIllegal: function (ArticleId, CommentId, ReportContent, fn) {
        apicmd.submitData(API_LIST.platform, "UserReport", "create", "", {
            ArticleId: ArticleId,
            CommentId: CommentId,
            ReportContent: ReportContent
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //拉黑
    blackSomeone: function (blackUserId, fn) {
        apicmd.submitData(API_LIST.platform, "UserAction", "FillInBlackList", "", {
            blackUserId: blackUserId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP首页根据栏目选择列表
    defaultColumnInfoList: function (PageId, ColumnId, fn,errfn) {
        apicmd.getData(API_LIST.platform, "article", "GetArticleListByColumn", "page=" + PageId + "&ColumnId=" + ColumnId + "&PageSize=10", {}, function (data, err) {
            for (i = 0; i < data.data.length; i++) {
                if (!data.data[i].CoverImage) {
                    data.data[i].CoverImage = [];
                }
                for (j = 0; j < data.data[i].CoverImage.length; j++) {
                    data.data[i].CoverImage[j] = replaceImg(data.data[i].CoverImage[j]);
                }
            };
            if (fn)
                fn(data, err);
        }, 'json', function (data, err) {
            if (errfn)
                errfn(data, err)
        });
    },
    //绑定验证
    getMesCode: function (sendtype,msgtype, mobile, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/User", "SendMobilegCode", "", {
            sendtype: sendtype,
            mobile: mobile,
            msgtype: msgtype,
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //上传视频
    uploadVideo: function (base64Str, ext, fn) {
        apicmd.submitData(API_LIST.platform, "Video", "Videoupload", "", {
            base64Str: base64Str,
            ext: ext
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //刷新sessionid
    sessionIdRefresh: function (sessionId, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/User", "RefreshSessionId", "", {
            SessionId: sessionId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP首页栏目列表
    defaultColumnList: function (fn) {
        apicmd.getData(API_LIST.platform, "column", "GetColunmList", "", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP首页栏目文章列表
    defaultColumnNewsList: function (page, columnId, fn) {
        apicmd.getData(API_LIST.platform, "article", "GetArticleListByColumn", "page=" + page + "&columnName=" + columnId, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP内页文章主楼
    detailNew: function (id, fn,errfn) {
        apicmd.getData(API_LIST.platform, "article", "GetArticleById", "id=" + id, {}, function (data, err) {
            data.data.Content = replaceImg(data.data.Content);
            if (fn)
                fn(data, err);
        }, 'json', function (data, err) {
            if (errfn)
                errfn(data,err)
        });
    },
    //APP内页文章回复列表
    detailReply: function (ArticleId, page, fn) {
        apicmd.getData(API_LIST.platform, "comment", "getCommentByArticleId", "ArticleId=" + ArticleId + "&page=" + page + "&pageSize=10", {}, function (data, err) {
            for (i = 0; i < data.data.length; i++) {
                data.data[i].Content = replaceImg(data.data[i].Content);
                //data.data[i].AuthorHeadUrl = replaceImg(data.data[i].AuthorHeadUrl);
            }
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP内页文章回复列表-只看楼主
    GetUserCommentsByArticleId: function (ArticleId,author, page, fn) {
        apicmd.getData(API_LIST.platform, "comment", "GetUserCommentsByArticleId", "ArticleId=" + ArticleId +"&author="+author+ "&page=" + page + "&pageSize=10", {}, function (data, err) {
            for (i = 0; i < data.data.length; i++) {
                data.data[i].Content = replaceImg(data.data[i].Content);
                //data.data[i].AuthorHeadUrl = replaceImg(data.data[i].AuthorHeadUrl);
            }
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP栏目列表
    GetColunmList: function (fn) {
        apicmd.getData(API_LIST.platform, "column", "GetColunmList", "page=1&pageSize=100", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP栏目标签列表
    GetColunm: function (id, fn) {
        apicmd.submitData(API_LIST.platform, "column", "GetColunm", "", { id: id }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP分类列表
    GetTagCategory: function (fn) {
        apicmd.getData(API_LIST.platform, "tag", "GetTagCategory", "", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP分类标签列表
    getListByCategory: function (Category, fn) {
        apicmd.submitData(API_LIST.platform, "tag", "getListByCategory", "", { Category: Category, page: 1, pageSize: 9999 }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP发帖
    post: function (Title, Content, categoryTags, NotEditTitle, fn) {
        apicmd.submitData(API_LIST.platform, "forum", "create", "", {
            Title: Title,
            Content: Content,
            categoryTags: categoryTags,
            NotEditTitle: NotEditTitle
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //灵桥市场发表文章
    mallcreate: function (Title, Content, categoryTags, fn) {
        apicmd.submitData(API_LIST.platform, "mall", "create", "", {
            Title: Title,
            Content: Content,
            categoryTags: categoryTags
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //灵桥市场修改文章
    malledit: function (Title, Content, categoryTags,ArticleId, fn) {
        apicmd.submitData(API_LIST.platform, "mall", "edit", "", {
            Title: Title,
            Content: Content,
            categoryTags: categoryTags,
            ArticleId:ArticleId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP评论
    reply: function (ArticleId, Content, RefCommentId, replyToCommentId, replyToAuthor, fn) {
        apicmd.submitData(API_LIST.platform, "comment", "create", "", {
            ArticleId: ArticleId,
            Content: Content,
            RefCommentId: RefCommentId,
            replyToCommentId: replyToCommentId,
            replyToAuthor: replyToAuthor,
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //是否关注
    GetConcernState: function (FriendUserName, fn) {
        apicmd.getData(API_LIST.MY, "wrapper/t_api", "GetConcernState", "FriendUserName=" + FriendUserName, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //点击关注
    follow: function (Whom, Type, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/t_api", "follow", "", {
            Whom: Whom,
            Type: Type
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //是否收藏
    didCollection: function (ArticleId, fn) {
        apicmd.getData(API_LIST.MY, "wrapper/UserFavorite", "IsArticelCollected", "", {
            ArticleId: ArticleId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //收藏
    Collection: function (ArticleId, Type, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/UserFavorite", "CollectOrCacnleArticle", "", {
            ArticleId: ArticleId,
            Type: Type
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //点赞
    addlike: function (ArticleId, fn) {
        apicmd.submitData(API_LIST.platform, "article", "addlike", "", {
            ArticleId: ArticleId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //评论点赞
    addreplylike: function (ArticleId, commentId, fn) {
        apicmd.submitData(API_LIST.platform, "comment", "addlike", "", {
            ArticleId: ArticleId,
            commentId: commentId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //选择私信发送
    GetAllFollowingAndFans: function (fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/t_api", "GetAllFollowingAndFans", "", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //点踩
    addunlike: function (ArticleId, fn) {
        apicmd.submitData(API_LIST.platform, "article", "addunlike", "", {
            ArticleId: ArticleId
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //版块文章列表/article/GetForumList
    GetForumList: function (tagname, page, fn) {
        apicmd.getData(API_LIST.platform, "article", "GetForumList", "tagname=" + tagname + "&page=" + page + "&pageSize=10&source=1", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //获取单个标签
    GetTagByName: function (tagName, fn) {
        apicmd.getData(API_LIST.platform, "tag", "GetTagByName", "tagName=" + tagName, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //查询账号是否已被注册
    IsRegisteredUser: function (RegisterName, fn) {
        apicmd.getData(API_LIST.MY, "wrapper/User", "IsRegisteredUser", "RegisterName=" + RegisterName + "&Type=2", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    GetUserListByAuthMobile: function (Mobile, fn) {
        apicmd.getData(API_LIST.MY, "wrapper/User", "GetUserListByAuthMobile", "Mobile=" + Mobile, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    Register: function (RegisterMobile, ValCode, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/User", "Register", "", {
            RegisterMobile: RegisterMobile,
            ValCode: ValCode
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    RegisterWithBindOldCnoolUser: function (RegisterMobile, ValCode, binduid, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/User", "RegisterWithBindOldCnoolUser", "", {
            RegisterMobile: RegisterMobile,
            ValCode: ValCode,
            binduid: binduid
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    CheckRegMobilegCode: function (Mobile, ValCode, fn) {
        apicmd.submitData(API_LIST.MY, "wrapper/User", "CheckRegMobilegCode", "", {
            Mobile: Mobile,
            ValCode: ValCode
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    GetHotForumStat: function (fn) {
        apicmd.getData(API_LIST.MY, "wrapper/Statistics", "GetHotForumStat", "", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    taggetList: function (fn) {
        apicmd.getData(API_LIST.platform, "tag", "getList", "IsmallTag=true&returnArr=true", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //APP搜索列表
    restSearch: function (searchName,page, fn) {
        apicmd.getData(API_LIST.so, "restSearch.aspx", "", "q=" + searchName + "&orderby=postdatetime" + "&page="+page, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //单条评论
    getCommentById: function (ArticleId, CommentId, fn) {
        apicmd.getData(API_LIST.platform, "comment", "getCommentById", "articleid=" + ArticleId + "&CommentId=" + CommentId, {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //单条评论子评论
    GetCommentsByCommentId: function (ArticleId, CommentId, page, fn) {
        apicmd.getData(API_LIST.platform, "comment", "GetCommentsByCommentId", "ArticleId=" + ArticleId + "&CommentId=" + CommentId+"&page="+page+"&pagesize=10", {}, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //修改评论
    CommentEdit: function (ArticleId, CommentId, Content, fn) {
        apicmd.submitData(API_LIST.platform, "comment", "edit", "", {
            ArticleId: ArticleId,
            CommentId: CommentId,
            Content: Content
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //删除评论
    delcomment: function (ArticleId, CommentId, log, fn) {
        apicmd.submitData(API_LIST.platform, "comment", "delcomment", "", {
            ArticleId: ArticleId,
            CommentId: CommentId,
            log: log
        }, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //板块热帖列表
    getForumViewRankList: function (tagname, fn) {
        apicmd.getData(API_LIST.platform, "article", "GetViewRankList", "tagname=" + tagname + "&pageSize=15", {}, function (data,err) {
            for (i = 0; i < data.data.length; i++) {
                if (!data.data[i].CoverImage) {
                    data.data[i].CoverImage = [];
                }
                for (j = 0; j < data.data[i].CoverImage.length; j++) {
                    data.data[i].CoverImage[j] = replaceImg(data.data[i].CoverImage[j]);
                }
            }
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //根据版块显示广告
    GetForumBannerAdv: function (tagName, fn) {
        apicmd.getData(API_LIST.platform, "Advertisement","GetMobileBannerAdv", "tagName=" +tagName,{}, function (data,err) {
            if (fn)
                fn(data,err);
        })
    },
    //GetEventById
    GetEventById: function (EventId, fn) {
        apicmd.getData(API_LIST.platform, "Event", "GetEventById", "EventId=" + EventId, {}, function (json, err) {
            if (fn)
                fn(json, err);
        });
    },
    //GetAdvListByTag
    GetAdvListByTag: function (tagName, fn) {
        apicmd.getData(API_LIST.platform, "Advertisement", "GetAdvListByTag", "Type=5&tagName=" + tagName, {}, function (json, err) {
            if (fn)
                fn(json, err);
        });
    },
    //NewsPublishGetList
    NewsPublishGetList: function (PointId, fn) {
        apicmd.getData(API_LIST.platform, "NewsPublish", "GetList", "PointId=" + PointId, {}, function (json, err) {
            if (fn)
                fn(json, err);
        });
    },
    //ApplySubmit
    ApplySubmit: function (datas, fn) {
        apicmd.submitData(API_LIST.platform, "Event", "ApplySubmit", "", datas, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //打赏文章
    RewardArticle: function (datas, fn) {
        apicmd.submitData(API_LIST.platform, "Reward", "Article", "", datas, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //文章日志
    RewardArticleLog: function (datas, fn) {
        apicmd.submitData(API_LIST.platform, "Reward", "ArticleLog", "", datas, function (data, err) {
            
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //用户打赏日志
    RewardUserLog: function (datas, fn) {
        apicmd.submitData(API_LIST.platform, "Reward", "UserLog", "", datas, function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //商品列表
    MallCommodityGetList: function ( fn) {
        apicmd.getData(API_LIST.mallapi, "MallCommodity", "GetList", "", {},function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    },
    //购买下单
    CreateOrder: function (datas, fn) {
        apicmd.submitData(API_LIST.mallapi, "MallOrder", "CreateOrder", "",datas,function (data, err) {
            if (fn)
                fn(data, err);
        }, 'json');
    }
}


